#define nX 3
#define nY 10
#define BOUNDVAL (nX/2 + nY/2)

#define AXIS byte
#define COLOUR byte

#define RED 0
#define WHITE 1
#define EMPTY 2

byte board[nX*nY];

proctype EmptySlot(AXIS i ; AXIS j)
{
  do
  :: d_step {
      i-2 >= 0 && j-1 >= 0;
      board[i*nY + j] = board[(i-2)*nY + (j-1)];
      board[(i-2)*nY + (j-1)] = EMPTY;
      i = i - 2;
      j = j - 1;
    }
  :: d_step {
      i-2 >= 0 && j+1 < nY;
      board[i*nY + j] = board[(i-2)*nY + (j+1)];
      board[(i-2)*nY + (j+1)] = EMPTY;
      i = i - 2;
      j = j + 1;
    }
  :: d_step {
      i-1 >= 0 && j-2 >= 0;
      board[i*nY + j] = board[(i-1)*nY + (j-2)];
      board[(i-1)*nY + (j-2)] = EMPTY;
      i = i - 1;
      j = j - 2;
    }
  :: d_step {
      i-1 >= 0 && j+2 < nY;
      board[i*nY + j] = board[(i-1)*nY + (j+2)];
      board[(i-1)*nY + (j+2)] = EMPTY;
      i = i - 1;
      j = j + 2;
    }
  :: d_step {
      i+1 < nX && j-2 >= 0;
      board[i*nY + j] = board[(i+1)*nY + (j-2)];
      board[(i+1)*nY + (j-2)] = EMPTY;
      i = i + 1;
      j = j - 2;
    }
  :: d_step {
      i+1 < nX && j+2 < nY;
      board[i*nY + j] = board[(i+1)*nY + (j+2)];
      board[(i+1)*nY + (j+2)] = EMPTY;
      i = i + 1;
      j = j + 2;
    }
  :: d_step {
      i+2 < nX && j-1 >= 0;
      board[i*nY + j] = board[(i+2)*nY + (j-1)];
      board[(i+2)*nY + (j-1)] = EMPTY;
      i = i + 2;
      j = j - 1;
    }
  :: d_step {
      i+2 < nX && j+1 < nY;
      board[i*nY + j] = board[(i+2)*nY + (j+1)];
      board[(i+2)*nY + (j+1)] = EMPTY;
      i = i + 2;
      j = j + 1;
    }
  od
}

init
{
  int i, j;

  atomic {
    i = 0;
    do
      :: i < nX ->
          j = 0;
          do
            :: j < nY ->
              if
                :: i == nX/2 && j == nY/2 ->
                  board[i*nY+j] = EMPTY;
                :: (i != nX/2 || j != nY/2)
                    && (i + j < BOUNDVAL || (i + j == BOUNDVAL && i < nX/2)) ->
                  board[i*nY+j] = WHITE;
                :: (i != nX/2 || j != nY/2)
                    && !(i + j < BOUNDVAL || (i + j == BOUNDVAL && i < nX/2)) ->
                  board[i*nY+j] = RED;
              fi;
              j++;
            :: j >= nY ->
              break;
          od;
          i++;
      :: i >= nX ->
          break;
    od;

    run EmptySlot(nX/2, nY/2);
  }
}
